unit decoupe;

interface

//uses
//   strings;
{Module de dcoupe de phrase en mots spar par un caractre constant}
const
   max_mot = 100;
type
   t_phrase = array[1..max_mot] of string[40];



procedure decouper(var buffer : ansistring;sep : char;  var mot : t_phrase; var nb_mot : integer);
procedure decouper_csv(buffer : string;    sep : char;  var mot : t_phrase; var nb_mot : integer);
// function trim(ch : string) : string;

implementation



{
function trim(ch : string): string;
var
   s   : string;
   i,l : integer;
begin
   i:=0;
   s:='';
   l:=length(ch);
   if l>0 then
   begin
      repeat
         inc(i);
      until (i=l) or (ch[i]<>' ');
      if (i<=l) then s:=copy(ch,i,l-i+1);

      l:=length(s);
      if l>0 then
         while s[l]=' ' do
         begin
            s:=copy(s,1,l-1);
            l:=length(s);
         end;
   end;
   trim:=s;
end;
}
procedure decouper(var buffer : ansistring;sep : char;  var mot : t_phrase; var nb_mot: integer );
var
   i,j,l : integer;
   mot_courant : string;
begin

   for j:=1 to max_mot do mot[j]:='';
   mot_courant:='';
   i:=1;
   j:=0;
   l:=length(buffer);

   if l>0 then
   begin
      repeat

         if buffer[i]<>sep then
         begin
            mot_courant:=mot_courant+buffer[i];
            inc(i);
         end
         else
         begin
            inc(j);      { Nouveau mot }
            mot[j]:=mot_courant;
            mot_courant:='';
            inc(i);      { On passe le sparateur }
         end;

      until i>l;
      inc(j);      { Dernier mot }
      mot[j]:=mot_courant;
   end;


   nb_mot:=j;
end;

procedure decouper_csv(buffer : string;sep : char;  var mot : t_phrase; var nb_mot : integer);
{ Dcoupe un chaine de caractres en recherchant les textes ENCADRES par DEUX caractres SEP (ex : guillemet)}
var
   i,j,l,deb : integer;
begin
   for j:=1 to max_mot do mot[j]:='';

   i:=0;
   j:=0;
   l:=length(buffer);

   if l>0 then
   repeat
      inc(i);
      if buffer[i]=sep then { Premier SEP trouv }
      begin
         deb:=i;
         repeat
             inc(i);
         until (buffer[i]=sep) or (i=l); { On cherche le second SEP de la fin d'un mot }
         if buffer[i]=sep then
         begin                           { on a trouv la fin d'un mot }
            inc(j);
            mot[j]:=copy(buffer,deb,i-deb+1);
         end;
      end;
   until i=l;
   nb_mot:=j;
end;

begin
end.
